searchNodes=[{"doc":"Provides functions to manipulate a game of Perudex.","ref":"Perudex.Game.html","title":"Perudex.Game","type":"module"},{"doc":"Play a Perudo move on the current game. A move can either be an outbid, a calza (exactly the same amount of dice as the previous bid) or a dudo (bid is too ambitious). Examples iex&gt; Perudex.Game . play_move ( ...&gt; % Perudex.Game { ...&gt; all_players : [ 1 , 2 ] , ...&gt; current_bid : { 2 , 3 } , ...&gt; current_player_id : 2 , ...&gt; instructions : [ ] , ...&gt; max_dice : 5 , ...&gt; players_hands : [ ...&gt; %{ ...&gt; hand : % Perudex.Hand { dice : [ 2 , 4 , 2 , 5 , 6 ] , remaining_dice : 5 } , ...&gt; player_id : 1 ...&gt; } , ...&gt; %{ ...&gt; hand : % Perudex.Hand { dice : [ 1 , 3 , 4 , 4 , 5 ] , remaining_dice : 5 } , ...&gt; player_id : 2 ...&gt; } ...&gt; ] , ...&gt; remaining_players : [ 1 , 2 ] ...&gt; } , ...&gt; 1 , ...&gt; { :outbid , { 2 , 3 } } ) { [ { :notify_player , 1 , { :last_move , 1 , { :outbid , { 2 , 3 } } } } , { :notify_player , 2 , { :last_move , 1 , { :outbid , { 2 , 3 } } } } , { :notify_player , 2 , :move } ] , % Perudex.Game { all_players : [ 1 , 2 ] , current_bid : { 2 , 3 } , current_player_id : 2 , instructions : [ ] , max_dice : 5 , players_hands : [ %{ hand : % Perudex.Hand { dice : [ 2 , 4 , 2 , 5 , 6 ] , remaining_dice : 5 } , player_id : 1 } , %{ hand : % Perudex.Hand { dice : [ 1 , 3 , 4 , 4 , 5 ] , remaining_dice : 5 } , player_id : 2 } ] , remaining_players : [ 1 , 2 ] } }","ref":"Perudex.Game.html#play_move/3","title":"Perudex.Game.play_move/3","type":"function"},{"doc":"Initialize a game of Perudo with players_ids and specified max_dice a player can hold. Returns a tuple containing a list of Perudex.Game.player_instruction() and a Perudex.Game struct. Examples iex&gt; :rand . seed ( :exsplus , { 101 , 102 , 103 } ) Perudex.Game . start ( [ 1 , 2 ] , 5 ) { [ { :notify_player , 1 , { :game_started , [ 1 , 2 ] } } , { :notify_player , 2 , { :game_started , [ 1 , 2 ] } } , { :notify_player , 1 , { :new_hand , % Perudex.Hand { dice : [ 5 , 5 , 2 , 6 , 4 ] , remaining_dice : 5 } } } , { :notify_player , 2 , { :new_hand , % Perudex.Hand { dice : [ 1 , 3 , 6 , 4 , 2 ] , remaining_dice : 5 } } } , { :notify_player , 1 , { :move , % Perudex.Hand { dice : [ 5 , 5 , 2 , 6 , 4 ] } } ] , % Perudex.Game { all_players : [ 1 , 2 ] , current_bid : { 0 , 0 } , current_player_id : 1 , instructions : [ ] , max_dice : 5 , players_hands : [ %{ hand : % Perudex.Hand { dice : [ 5 , 5 , 2 , 6 , 4 ] , remaining_dice : 5 } , player_id : 1 } , %{ hand : % Perudex.Hand { dice : [ 1 , 3 , 6 , 4 , 2 ] , remaining_dice : 5 } , player_id : 2 } ] , remaining_players : [ 1 , 2 ] } }","ref":"Perudex.Game.html#start/2","title":"Perudex.Game.start/2","type":"function"},{"doc":"","ref":"Perudex.Game.html#t:bid/0","title":"Perudex.Game.bid/0","type":"type"},{"doc":"","ref":"Perudex.Game.html#t:instruction/0","title":"Perudex.Game.instruction/0","type":"type"},{"doc":"","ref":"Perudex.Game.html#t:move/0","title":"Perudex.Game.move/0","type":"type"},{"doc":"","ref":"Perudex.Game.html#t:move_result/0","title":"Perudex.Game.move_result/0","type":"type"},{"doc":"","ref":"Perudex.Game.html#t:player_id/0","title":"Perudex.Game.player_id/0","type":"type"},{"doc":"","ref":"Perudex.Game.html#t:player_instruction/0","title":"Perudex.Game.player_instruction/0","type":"type"},{"doc":"","ref":"Perudex.Game.html#t:t/0","title":"Perudex.Game.t/0","type":"opaque"},{"doc":"This module define the Registry to keep the game state in memory.","ref":"Perudex.GameRegistry.html","title":"Perudex.GameRegistry","type":"module"},{"doc":"","ref":"Perudex.GameRegistry.html#child_spec/0","title":"Perudex.GameRegistry.child_spec/0","type":"function"},{"doc":"This module is a GenServer implementation to control the Perudo game state.","ref":"Perudex.GameServer.html","title":"Perudex.GameServer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Perudex.GameServer.html#child_spec/1","title":"Perudex.GameServer.child_spec/1","type":"function"},{"doc":"","ref":"Perudex.GameServer.html#move/3","title":"Perudex.GameServer.move/3","type":"function"},{"doc":"","ref":"Perudex.GameServer.html#start_link/1","title":"Perudex.GameServer.start_link/1","type":"function"},{"doc":"","ref":"Perudex.GameServer.html#t:callback_arg/0","title":"Perudex.GameServer.callback_arg/0","type":"type"},{"doc":"","ref":"Perudex.GameServer.html#t:id/0","title":"Perudex.GameServer.id/0","type":"type"},{"doc":"","ref":"Perudex.GameServer.html#t:player/0","title":"Perudex.GameServer.player/0","type":"type"},{"doc":"Provides functions to manipulate a hand of dice in Perudex.","ref":"Perudex.Hand.html","title":"Perudex.Hand","type":"module"},{"doc":"Add a die to the hand if the maximum defined by game rules is not busted. Examples: iex&gt; Perudex.Hand . add ( % Perudex.Hand { remaining_dice : 4 } ) % Perudex.Hand { remaining_dice : 5 , dice : nil }","ref":"Perudex.Hand.html#add/1","title":"Perudex.Hand.add/1","type":"function"},{"doc":"Initialize a new hand for a player given his allowed dice holding count. Examples: iex&gt; hand = Perudex.Hand . new ( % Perudex.Hand { remaining_dice : 5 } ) iex&gt; %{ remaining_dice : 5 } = hand iex&gt; length ( hand . dice ) == hand . remaining_dice","ref":"Perudex.Hand.html#new/1","title":"Perudex.Hand.new/1","type":"function"},{"doc":"Remove a die from the hand if it is not empty. Examples: iex&gt; Perudex.Hand . take ( % Perudex.Hand { remaining_dice : 5 } ) % Perudex.Hand { remaining_dice : 4 , dice : nil } iex&gt; Perudex.Hand . take ( % Perudex.Hand { remaining_dice : 0 } ) % Perudex.Hand { remaining_dice : 0 , dice : nil }","ref":"Perudex.Hand.html#take/1","title":"Perudex.Hand.take/1","type":"function"},{"doc":"","ref":"Perudex.Hand.html#t:die/0","title":"Perudex.Hand.die/0","type":"type"},{"doc":"","ref":"Perudex.Hand.html#t:t/0","title":"Perudex.Hand.t/0","type":"type"},{"doc":"This module is a GenServer to handle communication going to the players by defining an interface a module need to implements.","ref":"Perudex.NotifierServer.html","title":"Perudex.NotifierServer","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Perudex.NotifierServer.html#child_spec/1","title":"Perudex.NotifierServer.child_spec/1","type":"function"},{"doc":"","ref":"Perudex.NotifierServer.html#c:illegal_move/2","title":"Perudex.NotifierServer.illegal_move/2","type":"callback"},{"doc":"","ref":"Perudex.NotifierServer.html#c:invalid_bid/2","title":"Perudex.NotifierServer.invalid_bid/2","type":"callback"},{"doc":"","ref":"Perudex.NotifierServer.html#c:last_move/4","title":"Perudex.NotifierServer.last_move/4","type":"callback"},{"doc":"","ref":"Perudex.NotifierServer.html#c:loser/3","title":"Perudex.NotifierServer.loser/3","type":"callback"},{"doc":"","ref":"Perudex.NotifierServer.html#c:move/3","title":"Perudex.NotifierServer.move/3","type":"callback"},{"doc":"","ref":"Perudex.NotifierServer.html#c:new_hand/3","title":"Perudex.NotifierServer.new_hand/3","type":"callback"},{"doc":"","ref":"Perudex.NotifierServer.html#publish/3","title":"Perudex.NotifierServer.publish/3","type":"function"},{"doc":"","ref":"Perudex.NotifierServer.html#c:reveal_players_hands/4","title":"Perudex.NotifierServer.reveal_players_hands/4","type":"callback"},{"doc":"","ref":"Perudex.NotifierServer.html#c:start_game/3","title":"Perudex.NotifierServer.start_game/3","type":"callback"},{"doc":"","ref":"Perudex.NotifierServer.html#start_link/1","title":"Perudex.NotifierServer.start_link/1","type":"function"},{"doc":"","ref":"Perudex.NotifierServer.html#c:unauthorized_move/2","title":"Perudex.NotifierServer.unauthorized_move/2","type":"callback"},{"doc":"","ref":"Perudex.NotifierServer.html#c:winner/3","title":"Perudex.NotifierServer.winner/3","type":"callback"},{"doc":"Supervisor for game servers","ref":"Perudex.Supervisors.GameSupervisor.html","title":"Perudex.Supervisors.GameSupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Perudex.Supervisors.GameSupervisor.html#child_spec/1","title":"Perudex.Supervisors.GameSupervisor.child_spec/1","type":"function"},{"doc":"","ref":"Perudex.Supervisors.GameSupervisor.html#start_child/2","title":"Perudex.Supervisors.GameSupervisor.start_child/2","type":"function"},{"doc":"","ref":"Perudex.Supervisors.GameSupervisor.html#start_link/1","title":"Perudex.Supervisors.GameSupervisor.start_link/1","type":"function"},{"doc":"Main supervisor to orchestrate other supervisors","ref":"Perudex.Supervisors.MainSupervisor.html","title":"Perudex.Supervisors.MainSupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Perudex.Supervisors.MainSupervisor.html#child_spec/1","title":"Perudex.Supervisors.MainSupervisor.child_spec/1","type":"function"},{"doc":"","ref":"Perudex.Supervisors.MainSupervisor.html#create_game/2","title":"Perudex.Supervisors.MainSupervisor.create_game/2","type":"function"},{"doc":"","ref":"Perudex.Supervisors.MainSupervisor.html#start_link/1","title":"Perudex.Supervisors.MainSupervisor.start_link/1","type":"function"},{"doc":"Supervisor for notifications servers","ref":"Perudex.Supervisors.NotifierSupervisor.html","title":"Perudex.Supervisors.NotifierSupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Perudex.Supervisors.NotifierSupervisor.html#child_spec/1","title":"Perudex.Supervisors.NotifierSupervisor.child_spec/1","type":"function"},{"doc":"","ref":"Perudex.Supervisors.NotifierSupervisor.html#start_child/2","title":"Perudex.Supervisors.NotifierSupervisor.start_child/2","type":"function"},{"doc":"","ref":"Perudex.Supervisors.NotifierSupervisor.html#start_link/1","title":"Perudex.Supervisors.NotifierSupervisor.start_link/1","type":"function"}]